"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationModule = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("./app/config/model/typeorm");
const skip_list_module_1 = require("./app/skip-list/skip-list.module");
const symbol_server_module_1 = require("./app/symbol-server/symbol-server.module");
const queue_module_1 = require("./app/queue/queue.module");
const universe_module_1 = require("./app/universe/universe.module");
const project_module_1 = require("./app/project/project.module");
const symbols_module_1 = require("./app/symbols/symbols.module");
const binary_module_1 = require("./app/binary/binary.module");
const helpers_module_1 = require("./app/helpers/helpers.module");
const logger_module_1 = require("./app/logger/logger.module");
const config_module_1 = require("./app/config/config.module");
const server_credentials_module_1 = require("./app/server-credentials/server-credentials.module");
const proxy_module_1 = require("./app/proxy/proxy.module");
const black_list_module_1 = require("./app/black-list/black-list.module");
const white_list_module_1 = require("./app/white-list/white-list.module");
const symbol_item_module_1 = require("./app/symbol-item/symbol-item.module");
const symbol_server_logs_module_1 = require("./app/symbol-server-logs/symbol-server-logs.module");
const coroner_module_1 = require("./app/coroner/coroner.module");
const metrics_module_1 = require("./app/metrics/metrics.module");
const middlewares_module_1 = require("./app/middlewares/middlewares.module");
const status_module_1 = require("./app/status/status.module");
const service_module_1 = require("./app/service/service.module");
const log_retention_module_1 = require("./app/log-retention/log-retention.module");
const symbol_server_priority_module_1 = require("./app/symbol-server-priority/symbol-server-priority.module");
const health_check_module_1 = require("./app/health-check/health-check.module");
const reprocess_module_1 = require("./app/reprocess/reprocess.module");
let ApplicationModule = class ApplicationModule {
};
ApplicationModule = __decorate([
    common_1.Module({
        imports: [
            typeorm_1.TypeOrmModule.forRootAsync({ useClass: typeorm_2.TypeOrmConfigService }),
            helpers_module_1.HelpersModule,
            queue_module_1.QueueModule,
            middlewares_module_1.MiddlewaresModule,
            project_module_1.ProjectModule,
            universe_module_1.UniverseModule,
            skip_list_module_1.SkipListModule,
            symbol_server_module_1.SymbolServerModule,
            binary_module_1.BinaryModule,
            symbols_module_1.SymbolsModule,
            server_credentials_module_1.ServerCredentialsModule,
            proxy_module_1.ProxyModule,
            black_list_module_1.BlackListModule,
            white_list_module_1.WhiteListModule,
            symbol_server_logs_module_1.SymbolServerLogsModule,
            coroner_module_1.CoronerModule,
            metrics_module_1.MetricsModule,
            status_module_1.StatusModule,
            service_module_1.ServiceModule,
            symbol_item_module_1.SymbolItemModule,
            config_module_1.ConfigModule,
            log_retention_module_1.LogRetentionModule,
            symbol_server_priority_module_1.SymbolServerPriorityModule,
            logger_module_1.LoggerModule,
            health_check_module_1.HealthCheckModule,
            reprocess_module_1.ReprocessModule
        ],
    })
], ApplicationModule);
exports.ApplicationModule = ApplicationModule;
//# sourceMappingURL=app.module.js.map