"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolFile = void 0;
const path_1 = require("path");
const bufferHelper_1 = require("../../../helpers/bufferHelper");
const symbolType_1 = require("./symbolType");
class SymbolFile {
    constructor(task) {
        this.task = task;
        this._type = symbolType_1.SymbolType.Unknown;
        this._savePath = task.fullSymboLPath;
        this.symbolName = task.symbolName;
        this.debugId = task.debugId;
        this._query = task.query;
        this.isFromGlobalSymbolServer = task.symbolServer.isGlobalSymbolServer;
    }
    get query() {
        return this._query;
    }
    get type() {
        return this._type;
    }
    get symbolPath() {
        return this._savePath;
    }
    async generateSymbolType() {
        this._type = await this.getType();
    }
    async getType() {
        if (this._type !== symbolType_1.SymbolType.Unknown) {
            return this._type;
        }
        const result = await bufferHelper_1.BufferHelper.getSymbolFromPath(this._savePath);
        if (result === symbolType_1.SymbolType.Unknown) {
            if (path_1.extname(this.symbolName) === '.dylib') {
                return symbolType_1.SymbolType.Elf;
            }
        }
        return result;
    }
}
exports.SymbolFile = SymbolFile;
//# sourceMappingURL=SymbolFile.js.map