"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskLogger = void 0;
const common_1 = require("@nestjs/common");
const logger_service_1 = require("../../../app/logger/logger.service");
const symbolServerLogType_1 = require("../../../database/entities/types/symbolServerLogType");
let TaskLogger = class TaskLogger {
    constructor(_loggerService) {
        this._loggerService = _loggerService;
    }
    debug(message) {
        this._loggerService.debug(message);
    }
    error(message, task) {
        this._loggerService.debug(message);
        if (task) {
            this.addLog(task, message, symbolServerLogType_1.SymbolServerLogType.Error);
        }
    }
    info(message, task) {
        this._loggerService.debug(message);
        if (task) {
            this.addLog(task, message, symbolServerLogType_1.SymbolServerLogType.Info);
        }
    }
    log(task, message) {
        this.addLog(task, message, symbolServerLogType_1.SymbolServerLogType.Info);
        this._loggerService.debug(message);
    }
    warn(message, task) {
        if (task) {
            this.addLog(task, message, symbolServerLogType_1.SymbolServerLogType.Warning);
        }
        this._loggerService.debug(message);
    }
    addLog(task, message, type) {
        if (!task.symbolServer.logs) {
            task.symbolServer.logs = [];
        }
        task.symbolServer.logs.unshift({
            message,
            type,
            creationDate: new Date(),
        });
    }
};
TaskLogger = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [logger_service_1.LoggerService])
], TaskLogger);
exports.TaskLogger = TaskLogger;
//# sourceMappingURL=taskLogger.js.map