"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigService = void 0;
const common_1 = require("@nestjs/common");
const env_1 = require("../../env");
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
let ConfigService = class ConfigService {
    constructor() {
        this._coronerdDiskPaths = [];
        this.readCoronerdUsedPaths();
    }
    get isProduction() {
        return process.env.NODE_ENV === 'production';
    }
    get isTest() {
        return process.env.NODE_ENV === 'test';
    }
    get isDevelopment() {
        return process.env.NODE_ENV === 'development';
    }
    get coronerdDiskPaths() {
        return this._coronerdDiskPaths;
    }
    get log() {
        return env_1.env.log;
    }
    get db() {
        return env_1.env.db;
    }
    get api() {
        return env_1.env.api;
    }
    get ssl() {
        return env_1.env.ssl;
    }
    get identityManager() {
        return env_1.service.identityManager;
    }
    get symbolServer() {
        return env_1.env.symbol_server;
    }
    get path() {
        return env_1.env.path;
    }
    readCoronerdUsedPaths() {
        const paths = env_1.env.path.coronerd;
        for (const coronerdPath of paths) {
            const coronerdConfPath = path_1.default.join(coronerdPath, 'coronerd.conf');
            if (!fs_1.default.existsSync(coronerdConfPath)) {
                continue;
            }
            try {
                const json = fs_1.default.readFileSync(coronerdConfPath, { encoding: 'utf8' });
                const conf = JSON.parse(json);
                if (conf) {
                    if (conf.symbold) {
                        if (conf.symbold.json) {
                            this.path.eventPaths.push(path_1.default.join(conf.symbold.json, 'new'));
                        }
                    }
                    if (conf.storage && conf.storage.disks) {
                        this._coronerdDiskPaths.push(...conf.storage.disks.map((d) => d.path));
                    }
                }
            }
            catch (err) {
                continue;
            }
        }
    }
};
ConfigService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [])
], ConfigService);
exports.ConfigService = ConfigService;
//# sourceMappingURL=config.service.js.map