"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeOrmConfigService = exports.typeOrmConf = void 0;
const typeorm_1 = require("typeorm");
const env_1 = require("../../../env");
exports.typeOrmConf = {
    name: 'default',
    type: env_1.env.db.type,
    host: env_1.env.db.host,
    port: env_1.env.db.port,
    username: env_1.env.db.username,
    password: env_1.env.db.password,
    database: env_1.env.db.database,
    migrationsRun: true,
    entities: [`${process.cwd()}/dist/database/entities/*.js`],
    migrations: [`${process.cwd()}/dist/database/migrations/*.js`],
    synchronize: false,
    options: {
        useUTC: false,
        encrypt: true,
    },
    extra: { connectionLimit: 10 },
};
class TypeOrmConfigService {
    async createTypeOrmOptions() {
        const connectionManager = typeorm_1.getConnectionManager();
        let options;
        if (connectionManager.has('default')) {
            options = connectionManager.get('default').options;
            await connectionManager.get('default').close();
        }
        else {
            options = exports.typeOrmConf;
        }
        return options;
    }
}
exports.TypeOrmConfigService = TypeOrmConfigService;
//# sourceMappingURL=typeorm.js.map