"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthCheckController = void 0;
const common_1 = require("@nestjs/common");
const health_check_service_1 = require("./health-check.service");
const config_service_1 = require("../config/config.service");
let HealthCheckController = class HealthCheckController {
    constructor(_healthCheckService, _configService) {
        this._healthCheckService = _healthCheckService;
        this._configService = _configService;
    }
    async status(res) {
        this._configService.identityManager.bypassProjectAccessCheck(res);
        res.send({
            version: this._healthCheckService.getApplicationVersion(),
            database: {
                connectionAvailable: await this._healthCheckService.validateDatabaseConnection(),
            },
            internet: {
                connectionAvailable: await this._healthCheckService.validateInternetAccess(),
            },
        });
    }
};
__decorate([
    common_1.Get(''),
    __param(0, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], HealthCheckController.prototype, "status", null);
HealthCheckController = __decorate([
    common_1.Controller('health'),
    __metadata("design:paramtypes", [health_check_service_1.HealthCheckService,
        config_service_1.ConfigService])
], HealthCheckController);
exports.HealthCheckController = HealthCheckController;
//# sourceMappingURL=health-check.controller.js.map