"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthCheckService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const logger_service_1 = require("../logger/logger.service");
const axios_1 = __importDefault(require("axios"));
const packageJson = require('../../../package.json');
let HealthCheckService = class HealthCheckService {
    constructor(_logger) {
        this._logger = _logger;
    }
    getApplicationVersion() {
        return packageJson.version;
    }
    async validateDatabaseConnection() {
        const connection = typeorm_1.getConnection();
        try {
            await connection.query('SELECT 1');
            return true;
        }
        catch (err) {
            this._logger.error(`Cannot connect to sqlite database. Reason: ${err.message}`);
            return false;
        }
    }
    async validateInternetAccess() {
        try {
            const result = await axios_1.default.get('https://8.8.8.8', { timeout: 800 });
            return result.status === 200;
        }
        catch (err) {
            return false;
        }
    }
};
HealthCheckService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [logger_service_1.LoggerService])
], HealthCheckService);
exports.HealthCheckService = HealthCheckService;
//# sourceMappingURL=health-check.service.js.map