"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DirectoryProvider = void 0;
const common_1 = require("@nestjs/common");
const fs = __importStar(require("fs"));
const fs_extra_1 = require("fs-extra");
const mkdirp_1 = __importDefault(require("mkdirp"));
const path = __importStar(require("path"));
const util = __importStar(require("util"));
let DirectoryProvider = class DirectoryProvider {
    async move(source, destination) {
        await fs_extra_1.move(source, destination, { overwrite: true });
    }
    async copy(source, destination) {
        await fs_extra_1.copy(source, destination, {
            overwrite: true,
            recursive: true,
        });
    }
    async exists(filePath) {
        try {
            await fs.promises.access(filePath);
            return true;
        }
        catch (err) {
            return false;
        }
    }
    async listAllFilesInDir(directory) {
        return await fs.promises.readdir(directory);
    }
    async remove(fullPath) {
        if (await this.exists(fullPath)) {
            await this._remove(fullPath);
        }
    }
    async createDirRecursively(dirPath, checkIfFile = false) {
        if (checkIfFile === true) {
            const isDir = path.extname(dirPath) === '';
            if (!isDir) {
                dirPath = path.dirname(dirPath);
            }
        }
        await util.promisify(mkdirp_1.default)(dirPath);
    }
    async createDir(dirPath) {
        await fs.promises.mkdir(dirPath);
    }
    async copyStat(src, dst) {
        const srcStat = await fs.promises.stat(src);
        await fs.promises.utimes(dst, srcStat.atime, srcStat.mtime);
    }
    async _remove(fullPath) {
        if (fs.lstatSync(fullPath).isDirectory() === false) {
            await fs.promises.unlink(fullPath);
            return;
        }
        const files = await this.listAllFilesInDir(fullPath);
        for (const file of files) {
            await this._remove(path.join(fullPath, file));
        }
        fs.rmdirSync(fullPath);
    }
};
DirectoryProvider = __decorate([
    common_1.Injectable(),
    common_1.Global()
], DirectoryProvider);
exports.DirectoryProvider = DirectoryProvider;
//# sourceMappingURL=directoryProvider.js.map