"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileProvider = void 0;
const common_1 = require("@nestjs/common");
const fs = __importStar(require("fs"));
const fs_extra_1 = require("fs-extra");
const path = __importStar(require("path"));
const stream_1 = require("stream");
const util_1 = __importDefault(require("util"));
const guidHelper_1 = require("../../helpers/guidHelper");
let FileProvider = class FileProvider {
    async exists(filePath) {
        return await util_1.default.promisify(fs.exists)(filePath);
    }
    async getSize(filePath) {
        const stats = await util_1.default.promisify(fs.stat)(filePath);
        return stats.size;
    }
    async rename(source, newName) {
        if (path.basename(source) === newName) {
            return;
        }
        const exists = await this.exists(source);
        if (!exists) {
            return;
        }
        await fs_extra_1.rename(source, newName);
    }
    async move(source, destination) {
        await fs_extra_1.move(source, destination, { overwrite: true });
    }
    async findInDirs(dirs, fileName) {
        if (!dirs || dirs.length === 0) {
            return undefined;
        }
        for (const dir of dirs) {
            const predictedPath = path.join(dir, fileName);
            const exists = await this.exists(predictedPath);
            if (exists) {
                return dir;
            }
        }
        return undefined;
    }
    async saveStream(filePath, content) {
        const tempPath = path.join(path.dirname(filePath), guidHelper_1.Guid.NewGuid());
        await util_1.default.promisify(stream_1.pipeline)(content, fs.createWriteStream(tempPath));
        await this.move(tempPath, filePath);
    }
    async delete(filePath) {
        if (!filePath || !(await this.exists(filePath))) {
            return;
        }
        await util_1.default.promisify(fs.unlink)(filePath);
    }
};
FileProvider = __decorate([
    common_1.Injectable(),
    common_1.Global()
], FileProvider);
exports.FileProvider = FileProvider;
//# sourceMappingURL=fileProvider.js.map