"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerService = void 0;
const common_1 = require("@nestjs/common");
const backtrace_node_1 = require("backtrace-node");
const winston_1 = __importDefault(require("winston"));
let LoggerService = class LoggerService extends common_1.Logger {
    constructor() {
        super();
    }
    debug(message, ...args) {
        winston_1.default.debug(this.formatScope(message), args);
    }
    log(message, context) {
        if (context) {
            super.log(message, context);
        }
        else {
            winston_1.default.info(this.formatScope(message));
        }
    }
    info(message, context) {
        if (context) {
            super.log(message, context);
        }
        else {
            this.log(message);
        }
    }
    error(message, trace, context) {
        if (context) {
            super.error(message, trace, context);
            return;
        }
        let error;
        if (message instanceof Error) {
            error = message;
        }
        else {
            error = new Error(message);
            error.stack = trace;
        }
        const client = backtrace_node_1.getBacktraceClient();
        if (client) {
            client.reportSync(error);
        }
        winston_1.default.error(this.formatScope(error.message), [error]);
    }
    warn(message, context) {
        if (context) {
            super.warn(message, context);
        }
        else {
            winston_1.default.warn(this.formatScope(message));
        }
    }
    formatScope(msg) {
        return `[${new Date().toLocaleString()}] ${msg}`;
    }
};
LoggerService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [])
], LoggerService);
exports.LoggerService = LoggerService;
//# sourceMappingURL=logger.service.js.map