"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProjectService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const project_1 = require("../../database/entities/project");
let ProjectService = class ProjectService {
    constructor(_projectRepository) {
        this._projectRepository = _projectRepository;
    }
    async getProjectIdByProjectName(projectName, universeName) {
        if (!projectName) {
            return undefined;
        }
        const project = await this.getByProjectName(projectName, universeName);
        return project ? project.id : undefined;
    }
    async getByProjectName(projectName, universeName) {
        if (!projectName || !universeName) {
            return undefined;
        }
        return await this._projectRepository
            .createQueryBuilder('project')
            .leftJoin('project.universe', 'universe')
            .where('LOWER(project.name) = LOWER(:projectName) and LOWER(universe.name) = LOWER(:universeName)', {
            projectName,
            universeName,
        })
            .getOne();
    }
    async getProjectNameById(id) {
        var _a;
        return (_a = (await this._projectRepository
            .createQueryBuilder('project')
            .select(['project.name'])
            .where('project.id = :id', { id })
            .getOne())) === null || _a === void 0 ? void 0 : _a.name;
    }
    async tryAdd(projectToAdd) {
        if (!projectToAdd || !projectToAdd.universeId) {
            return undefined;
        }
        let project = await this._projectRepository.findOne({
            where: {
                name: projectToAdd.name,
                universeId: projectToAdd.universeId,
            },
        });
        if (!project) {
            project = await this.add(projectToAdd);
        }
        return project;
    }
    async add(project) {
        const data = await this._projectRepository.save(project);
        return data;
    }
};
ProjectService = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(project_1.Project)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], ProjectService);
exports.ProjectService = ProjectService;
//# sourceMappingURL=project.service.js.map