"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxyService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const proxy_1 = require("../../database/entities/proxy");
const typeorm_2 = require("typeorm");
let ProxyService = class ProxyService {
    constructor(_proxyRepository) {
        this._proxyRepository = _proxyRepository;
    }
    async setupEntity(symbolServerId, proxy) {
        const proxyEntity = await this.getProxyBySymbolServerId(symbolServerId);
        if (proxyEntity && !proxy) {
            await this.delete(proxyEntity.id);
        }
        else if (proxyEntity && proxy) {
            await this.update(proxyEntity.id, proxyEntity, proxy);
        }
        else if (proxy) {
            const entity = proxy;
            entity.symbolServerId = symbolServerId;
            await this.insert(entity);
        }
    }
    async insert(model) {
        const entity = this._proxyRepository.create(model);
        this._proxyRepository.save(entity);
    }
    async getProxyBySymbolServerId(symbolServerId) {
        return await this._proxyRepository.findOne({
            join: {
                alias: 'proxy',
                innerJoin: {
                    symbolServer: 'proxy.symbolServer',
                },
            },
            where: {
                symbolServer: {
                    id: symbolServerId,
                },
            },
        });
    }
    async update(id, entity, proxy) {
        const updateEntity = Object.assign({}, entity, proxy);
        this._proxyRepository.update(id, updateEntity);
    }
    async delete(id) {
        await this._proxyRepository.delete(id);
    }
};
ProxyService = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(proxy_1.Proxy)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], ProxyService);
exports.ProxyService = ProxyService;
//# sourceMappingURL=proxy.service.js.map