"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateCoronerEvent = void 0;
const class_validator_1 = require("class-validator");
const common_1 = require("@nestjs/common");
class CreateCoronerEvent {
    constructor() {
        this.missingSymbols = [];
    }
    validateMissingSymbols() {
        if (this.missingSymbols) {
            for (const missingSymbol of this.missingSymbols) {
                const parts = missingSymbol.split(',');
                if (!parts || parts.length !== 2) {
                    throw new common_1.BadRequestException('Invalid missing symbols separator. Required separator: ,');
                }
            }
        }
    }
}
__decorate([
    class_validator_1.IsNumber(undefined, { message: 'Incorrect type of obejctId' }),
    __metadata("design:type", Number)
], CreateCoronerEvent.prototype, "objectId", void 0);
__decorate([
    class_validator_1.ArrayNotEmpty({ message: 'require at least one missing symbol' }),
    class_validator_1.IsString({ each: true }),
    __metadata("design:type", Array)
], CreateCoronerEvent.prototype, "missingSymbols", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: 'UniverseName is required' }),
    class_validator_1.IsString({ message: 'Invalid UniverseName type' }),
    __metadata("design:type", String)
], CreateCoronerEvent.prototype, "universeName", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: 'ProjectName is required' }),
    class_validator_1.IsString({ message: 'Invalid ProjectName type' }),
    __metadata("design:type", String)
], CreateCoronerEvent.prototype, "projectName", void 0);
exports.CreateCoronerEvent = CreateCoronerEvent;
//# sourceMappingURL=createCoronerEvent.js.map