"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReprocessController = void 0;
const common_1 = require("@nestjs/common");
const authGuard_1 = require("../../guards/authGuard");
const authHelper_1 = require("../../helpers/authHelper");
const config_service_1 = require("../config/config.service");
const logger_service_1 = require("../logger/logger.service");
const reprocess_service_1 = require("./reprocess.service");
let ReprocessController = class ReprocessController {
    constructor(_logger, _configService, _reprocessingService) {
        this._logger = _logger;
        this._configService = _configService;
        this._reprocessingService = _reprocessingService;
    }
    async reprocess(req, res, data) {
        if (!data || !data.objectId) {
            throw new common_1.BadRequestException('Missing objectId');
        }
        if (!authHelper_1.AuthHelper.checkUserAccess(req.coronerAuth, data.universeName)) {
            this._configService.identityManager.bypassProjectAccessCheck(res);
            this._logger.warn(`User without access to universe tried to retrieve data. ${data.universeName}}`);
            throw new common_1.UnauthorizedException();
        }
        this._configService.identityManager.bypassProjectAccessCheck(res);
        this._logger.info(`Reprocessing data`);
        res.send(await this._reprocessingService.reprocess(data.universeName, data.projectName, data.objectId));
    }
};
__decorate([
    common_1.Post(''),
    __param(0, common_1.Req()),
    __param(1, common_1.Res()),
    __param(2, common_1.Body(new common_1.ValidationPipe({ transform: true }))),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ReprocessController.prototype, "reprocess", null);
ReprocessController = __decorate([
    common_1.Controller('reprocess'),
    common_1.UseGuards(authGuard_1.AuthGuard),
    __metadata("design:paramtypes", [logger_service_1.LoggerService,
        config_service_1.ConfigService,
        reprocess_service_1.ReprocessService])
], ReprocessController);
exports.ReprocessController = ReprocessController;
//# sourceMappingURL=reprocess.controller.js.map