"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerCredentialsOptions = void 0;
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const serverCredentials_1 = require("../../../database/entities/serverCredentials");
const credentialsType_1 = require("../../../database/entities/types/credentialsType");
const booleanPipe_1 = require("../../symbol-server/pipes/booleanPipe");
const awsOptions_1 = require("./awsOptions");
class ServerCredentialsOptions {
    get accessKeyId() {
        return this.userName;
    }
    get secretAccessKey() {
        return this.password;
    }
}
__decorate([
    class_validator_1.IsNotEmpty({ message: 'Username/AccessId is required', groups: ['basic', 'aws'] }),
    class_validator_1.IsString({ message: 'Incorrect username type or access id', groups: ['basic', 'aws'] }),
    __metadata("design:type", String)
], ServerCredentialsOptions.prototype, "userName", void 0);
__decorate([
    class_transformer_1.Type(() => Number),
    class_validator_1.IsNumber(undefined, { message: 'Incorrect type for property server credentials type' }),
    class_validator_1.Min(0, { message: 'server credentials type should be greater or equal to 0' }),
    class_validator_1.Max(2, { message: 'server credentials type should be less or equal to 2' }),
    __metadata("design:type", Number)
], ServerCredentialsOptions.prototype, "type", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: 'Secret is required', groups: ['basic'] }),
    class_validator_1.IsString({ message: 'Incorrect secret type', groups: ['basic'] }),
    __metadata("design:type", String)
], ServerCredentialsOptions.prototype, "password", void 0);
__decorate([
    class_validator_1.IsString({ message: 'Incorrect bucketName type', groups: ['gcp', 'aws', 'basic'] }),
    class_validator_1.IsNotEmpty({ message: 'BucketName is required' }),
    __metadata("design:type", String)
], ServerCredentialsOptions.prototype, "bucketName", void 0);
__decorate([
    class_transformer_1.Transform((value) => {
        if (booleanPipe_1.BooleanPipe.transformStringToBool(value)) {
            return 1;
        }
        else {
            return 0;
        }
    }),
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber(undefined, {
        message: 'Incorrect lowFile type',
        groups: ['gcp', 'aws', 'basic'],
    }),
    __metadata("design:type", Number)
], ServerCredentialsOptions.prototype, "lowerFile", void 0);
__decorate([
    class_transformer_1.Transform((value) => {
        if (booleanPipe_1.BooleanPipe.transformStringToBool(value)) {
            return 1;
        }
        else {
            return 0;
        }
    }),
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber(undefined, {
        message: ' Incorrect lowerId type',
        groups: ['gcp', 'aws', 'basic'],
    }),
    __metadata("design:type", Number)
], ServerCredentialsOptions.prototype, "lowerId", void 0);
__decorate([
    class_transformer_1.Transform((value) => {
        return booleanPipe_1.BooleanPipe.transformStringToBool(value);
    }),
    class_validator_1.IsOptional(),
    class_validator_1.IsBoolean({ message: 'Incorrect usePdb type', groups: ['gcp', 'aws', 'basic'] }),
    __metadata("design:type", Boolean)
], ServerCredentialsOptions.prototype, "usePdb", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => awsOptions_1.AwsOptions),
    __metadata("design:type", awsOptions_1.AwsOptions)
], ServerCredentialsOptions.prototype, "awsConnection", void 0);
exports.ServerCredentialsOptions = ServerCredentialsOptions;
//# sourceMappingURL=authOptions.js.map