"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerCredentialsService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const serverCredentials_1 = require("../../database/entities/serverCredentials");
const typeorm_2 = require("typeorm");
let ServerCredentialsService = class ServerCredentialsService {
    constructor(_serverCredentialsRepository) {
        this._serverCredentialsRepository = _serverCredentialsRepository;
    }
    async setupEntity(symbolServerId, options) {
        const credentialsEntity = await this.getBySymbolServerId(symbolServerId);
        if (credentialsEntity && !options) {
            await this.delete(credentialsEntity.id);
        }
        else if (credentialsEntity && options) {
            await this.update(credentialsEntity.id, credentialsEntity, options);
        }
        else if (options) {
            const entity = Object.assign({}, options);
            entity.symbolServerId = symbolServerId;
            await this.insert(entity);
        }
    }
    async insert(model) {
        const entity = this._serverCredentialsRepository.create(model);
        this._serverCredentialsRepository.save(entity);
    }
    async getBySymbolServerId(symbolServerId) {
        return await this._serverCredentialsRepository.findOne({
            join: {
                alias: 'creds',
                innerJoin: {
                    symbolServer: 'creds.symbolServer',
                },
            },
            where: {
                symbolServer: {
                    id: symbolServerId,
                },
            },
        });
    }
    async update(id, entity, options) {
        const updateEntity = Object.assign({}, entity, options);
        await this._serverCredentialsRepository.save(updateEntity);
    }
    async delete(id) {
        await this._serverCredentialsRepository.delete(id);
    }
};
ServerCredentialsService = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(serverCredentials_1.ServerCredentials)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], ServerCredentialsService);
exports.ServerCredentialsService = ServerCredentialsService;
//# sourceMappingURL=server-credentials.service.js.map