"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolItemCacheService = void 0;
const common_1 = require("@nestjs/common");
let SymbolItemCacheService = class SymbolItemCacheService {
    constructor() {
        this.symbolsCache = new Map();
        setInterval(() => {
            this.symbolsCache.clear();
        }, 3600000);
    }
    addSymbolToCache(key, missingSymbol, skipList) {
        const cache = this.symbolsCache.get(key);
        const payload = { path: missingSymbol, skipList };
        if (!cache) {
            this.symbolsCache.set(key, [payload]);
            return;
        }
        cache.push(payload);
    }
    symbolInCache(key, missingSymbols) {
        var _a;
        return (_a = this.symbolsCache.get(key)) === null || _a === void 0 ? void 0 : _a.find((n) => n.path === missingSymbols);
    }
    clear() {
        this.symbolsCache.clear();
    }
};
SymbolItemCacheService = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [])
], SymbolItemCacheService);
exports.SymbolItemCacheService = SymbolItemCacheService;
//# sourceMappingURL=symbol-item-cache.service.js.map