"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolServerLogsController = void 0;
const authGuard_1 = require("./../../guards/authGuard");
const common_1 = require("@nestjs/common");
const symbol_server_logs_service_1 = require("./symbol-server-logs.service");
const logger_service_1 = require("../logger/logger.service");
const parseOptionalInt_1 = require("../../pipes/parseOptionalInt");
const symbol_server_service_1 = require("../symbol-server/symbol-server.service");
const config_service_1 = require("../config/config.service");
let SymbolServerLogsController = class SymbolServerLogsController {
    constructor(_logger, _symbolServerService, _symbolServerLogsService, _configService) {
        this._logger = _logger;
        this._symbolServerService = _symbolServerService;
        this._symbolServerLogsService = _symbolServerLogsService;
        this._configService = _configService;
    }
    async get(req, res, symbolServerId, page, take) {
        await this._symbolServerService.validateSymbolServerAccessWithProjectAccess(this._configService, req, res, symbolServerId);
        this._logger.info(`Returning ${take} logs for symbol servers  with id ${symbolServerId} from page ${page}, `);
        const results = await this._symbolServerLogsService.getBySymbolServerId(symbolServerId, page, take);
        res.send(results);
    }
    async search(req, res, symbolServerId, text, page, take) {
        await this._symbolServerService.validateSymbolServerAccessWithProjectAccess(this._configService, req, res, symbolServerId);
        this._logger.info(`Returning ${take} logs for symbol servers  with id ${symbolServerId} from page ${page}, `);
        const results = await this._symbolServerLogsService.getByText(symbolServerId, text, page, take);
        res.send(results);
    }
};
__decorate([
    common_1.Get(':symbolServerId'),
    __param(0, common_1.Req()),
    __param(1, common_1.Res()),
    __param(2, common_1.Param('symbolServerId', new common_1.ParseIntPipe())),
    __param(3, common_1.Query('page', new parseOptionalInt_1.ParseOptionalIntPipe())),
    __param(4, common_1.Query('take', new parseOptionalInt_1.ParseOptionalIntPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Number, Object, Object]),
    __metadata("design:returntype", Promise)
], SymbolServerLogsController.prototype, "get", null);
__decorate([
    common_1.Get(':symbolServerId/text'),
    __param(0, common_1.Req()),
    __param(1, common_1.Res()),
    __param(2, common_1.Param('symbolServerId', new common_1.ParseIntPipe())),
    __param(3, common_1.Query('text')),
    __param(4, common_1.Query('page', new parseOptionalInt_1.ParseOptionalIntPipe())),
    __param(5, common_1.Query('take', new parseOptionalInt_1.ParseOptionalIntPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Number, String, Object, Object]),
    __metadata("design:returntype", Promise)
], SymbolServerLogsController.prototype, "search", null);
SymbolServerLogsController = __decorate([
    common_1.Controller('logs/symbolserver'),
    common_1.UseGuards(authGuard_1.AuthGuard),
    __metadata("design:paramtypes", [logger_service_1.LoggerService,
        symbol_server_service_1.SymbolServerService,
        symbol_server_logs_service_1.SymbolServerLogsService,
        config_service_1.ConfigService])
], SymbolServerLogsController);
exports.SymbolServerLogsController = SymbolServerLogsController;
//# sourceMappingURL=symbol-server-logs.controller.js.map