"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolServerLogsService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const symbolServerLog_1 = require("../../database/entities/symbolServerLog");
let SymbolServerLogsService = class SymbolServerLogsService {
    constructor(_symbolServerLogRepository) {
        this._symbolServerLogRepository = _symbolServerLogRepository;
    }
    async countLogs() {
        return await this._symbolServerLogRepository.count();
    }
    async getByTextAndUniverseData(universeName, projectName, text, page = 0, take = 10) {
        if (!text) {
            return [[], 0];
        }
        return this._symbolServerLogRepository
            .createQueryBuilder('log')
            .leftJoin('log.symbolServer', 'symbolServer')
            .leftJoin('symbolServer.universe', 'universe')
            .leftJoin('symbolServer.project', 'project')
            .leftJoin('project.universe', 'universeProject')
            .where(`log.message like :text 
        AND ((symbolServer.projectId is NULL and symbolServer.universeId is NULL)
        OR  (universe.name = :universeName)
        OR (project.name = :projectName AND universeProject.name = :universeProjectName))`, {
            text: `%${text}%`,
            universeName,
            projectName,
            universeProjectName: universeName,
        })
            .skip(page * take)
            .take(take)
            .orderBy('log.creationDate', 'DESC')
            .getManyAndCount();
    }
    async getByText(symbolServerId, text, page = 0, take = 10) {
        if (!text) {
            return [[], 0];
        }
        return this._symbolServerLogRepository
            .createQueryBuilder('log')
            .leftJoin('log.symbolServer', 'symbolServer')
            .where(`symbolServer.id = :symbolServerId AND log.message like :text `, {
            symbolServerId,
            text: `%${text}%`,
        })
            .skip(page * take)
            .take(take)
            .orderBy('log.creationDate', 'DESC')
            .getManyAndCount();
    }
    async getBySymbolServerId(symbolServerId, page = 0, take = 10) {
        return this._symbolServerLogRepository
            .createQueryBuilder('log')
            .leftJoin('log.symbolServer', 'symbolServer')
            .where(`symbolServer.id = :symbolServerId`, {
            symbolServerId,
        })
            .skip(page * take)
            .take(take)
            .orderBy('log.creationDate', 'DESC')
            .getManyAndCount();
    }
    async addCollection(symbolServerId, logs) {
        if (!logs) {
            return;
        }
        logs.map((n) => (n.symbolServerId = symbolServerId));
        await this._symbolServerLogRepository.save(logs, { chunk: logs.length / 100 });
    }
};
SymbolServerLogsService = __decorate([
    common_1.Injectable(),
    __param(0, typeorm_1.InjectRepository(symbolServerLog_1.SymbolServerLog)),
    __metadata("design:paramtypes", [typeorm_2.Repository])
], SymbolServerLogsService);
exports.SymbolServerLogsService = SymbolServerLogsService;
//# sourceMappingURL=symbol-server-logs.service.js.map