"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateSymbolServer = void 0;
const class_validator_1 = require("class-validator");
const authOptions_1 = require("../../server-credentials/dto/authOptions");
const proxyOptions_1 = require("../../proxy/dto/proxyOptions");
const class_transformer_1 = require("class-transformer");
const booleanPipe_1 = require("../pipes/booleanPipe");
class UpdateSymbolServer {
}
__decorate([
    class_validator_1.IsString({ message: 'Incorrect url type', groups: ['default'] }),
    class_validator_1.IsUrl(undefined, { message: 'Invalid url', groups: ['default'] }),
    class_validator_1.IsOptional({ groups: ['default'] }),
    __metadata("design:type", String)
], UpdateSymbolServer.prototype, "url", void 0);
__decorate([
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsString({ message: 'Incorrect type for property name', groups: ['default'] }),
    __metadata("design:type", String)
], UpdateSymbolServer.prototype, "name", void 0);
__decorate([
    class_transformer_1.Type(() => Number),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsNumber(undefined, {
        message: 'Incorrect type for property numberOfConcurrentDownload',
        groups: ['default'],
    }),
    __metadata("design:type", Number)
], UpdateSymbolServer.prototype, "numberOfConcurrentDownload", void 0);
__decorate([
    class_transformer_1.Type(() => Number),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsNumber(undefined, { message: 'Incorrect type for property retryLimit', groups: ['default'] }),
    __metadata("design:type", Number)
], UpdateSymbolServer.prototype, "retryLimit", void 0);
__decorate([
    class_transformer_1.Type(() => Number),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsNumber(undefined, { message: 'Incorrect type for property retryTimeout', groups: ['default'] }),
    class_validator_1.Min(30000, { message: 'Retry timeout should be greater than 30sec', groups: ['default'] }),
    __metadata("design:type", Number)
], UpdateSymbolServer.prototype, "retryTimeout", void 0);
__decorate([
    class_transformer_1.Type(() => Number),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsNumber(undefined, { message: 'Incorrect type for property timeout', groups: ['default'] }),
    class_validator_1.Min(10000, { message: 'Retry timeout should be greater than 10sec', groups: ['default'] }),
    __metadata("design:type", Number)
], UpdateSymbolServer.prototype, "timeout", void 0);
__decorate([
    class_transformer_1.Transform((value) => {
        return booleanPipe_1.BooleanPipe.transformStringToBool(value);
    }),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsBoolean({ message: 'Incorrect type for property whitelist', groups: ['default'] }),
    __metadata("design:type", Boolean)
], UpdateSymbolServer.prototype, "whiteList", void 0);
__decorate([
    class_transformer_1.Transform((value) => {
        return booleanPipe_1.BooleanPipe.transformStringToBool(value);
    }),
    class_validator_1.IsOptional({ groups: ['default'] }),
    class_validator_1.IsBoolean({ message: 'Invalid ignore property type', groups: ['default'] }),
    __metadata("design:type", Boolean)
], UpdateSymbolServer.prototype, "ignoreCredentials", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => authOptions_1.ServerCredentialsOptions),
    __metadata("design:type", authOptions_1.ServerCredentialsOptions)
], UpdateSymbolServer.prototype, "serverCredentials", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => proxyOptions_1.ProxyOptions),
    __metadata("design:type", proxyOptions_1.ProxyOptions)
], UpdateSymbolServer.prototype, "proxy", void 0);
exports.UpdateSymbolServer = UpdateSymbolServer;
//# sourceMappingURL=updateSymbolServer.js.map