"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateServerCredentialsPipe = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const fs_1 = __importDefault(require("fs"));
const credentialsType_1 = require("../../../database/entities/types/credentialsType");
const updateSymbolServer_1 = require("../dto/updateSymbolServer");
let UpdateServerCredentialsPipe = class UpdateServerCredentialsPipe {
    constructor(request) {
        this.request = request;
    }
    async transform(value, metadata) {
        var _a, _b, _c, _d, _e, _f;
        if (!value) {
            throw new common_1.BadRequestException('Undefined symbol server settings');
        }
        const groups = ['default'];
        if (value.serverCredentials || metadata.type === 'body') {
            const credentials = value.serverCredentials;
            if (credentials && credentials.awsConnection) {
                value.serverCredentials.type = credentialsType_1.CredentialsType.AWS;
                value.serverCredentials.bucketName = credentials.awsConnection.bucketName;
                value.serverCredentials.lowerFile = credentials.awsConnection.lowerFile;
                value.serverCredentials.lowerId = credentials.awsConnection.lowerId;
                value.serverCredentials.usePdb = credentials.awsConnection.usePdb;
                groups.push('aws');
            }
            else if (this.request.file && this.request.file.path) {
                if (!value.serverCredentials) {
                    value.serverCredentials = {};
                }
                value.serverCredentials.secretFile = this.request.file.path;
                value.serverCredentials.type = credentialsType_1.CredentialsType.GCP;
                if (!value.url) {
                    value.url = 'https://storage.googleapis.com';
                }
                if (value.url !== 'https://storage.googleapis.com' &&
                    value.url !== 'https://storage.cloud.google.com') {
                    if ((_a = this.request.file) === null || _a === void 0 ? void 0 : _a.path) {
                        fs_1.default.unlinkSync((_b = this.request.file) === null || _b === void 0 ? void 0 : _b.path);
                    }
                    throw new common_1.BadRequestException('GCP symbol server url should be equal to https://storage.googleapis.com or https://storage.cloud.google.com');
                }
                groups.push('gcp');
            }
            if (groups.length === 0) {
                if ((_c = this.request.file) === null || _c === void 0 ? void 0 : _c.path) {
                    fs_1.default.unlinkSync((_d = this.request.file) === null || _d === void 0 ? void 0 : _d.path);
                }
                if (value.serverCredentials) {
                    value.serverCredentials.type = credentialsType_1.CredentialsType.Default;
                }
                groups.push('basic');
            }
        }
        const model = class_transformer_1.plainToClass(updateSymbolServer_1.UpdateSymbolServer, value, { groups });
        const errors = await class_validator_1.validate(model, { groups });
        if (errors.length > 0) {
            if ((_e = this.request.file) === null || _e === void 0 ? void 0 : _e.path) {
                fs_1.default.unlinkSync((_f = this.request.file) === null || _f === void 0 ? void 0 : _f.path);
            }
            throw new common_1.BadRequestException(errors[0]);
        }
        return model;
    }
};
UpdateServerCredentialsPipe = __decorate([
    common_1.Injectable({ scope: common_1.Scope.REQUEST }),
    __param(0, common_1.Inject(core_1.REQUEST)),
    __metadata("design:paramtypes", [Object])
], UpdateServerCredentialsPipe);
exports.UpdateServerCredentialsPipe = UpdateServerCredentialsPipe;
//# sourceMappingURL=updateServerCredentialsPipe.js.map