"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SymbolServerModule = void 0;
const common_1 = require("@nestjs/common");
const symbol_server_service_1 = require("./symbol-server.service");
const symbol_server_controller_1 = require("./symbol-server.controller");
const symbolServer_1 = require("../../database/entities/symbolServer");
const typeorm_1 = require("@nestjs/typeorm");
const project_module_1 = require("../project/project.module");
const server_credentials_module_1 = require("../server-credentials/server-credentials.module");
const proxy_module_1 = require("../proxy/proxy.module");
const symbol_item_module_1 = require("../symbol-item/symbol-item.module");
const symbolServer_startup_1 = require("./symbolServer.startup");
const universe_module_1 = require("../universe/universe.module");
const platform_express_1 = require("@nestjs/platform-express");
const env_1 = require("../../env");
let SymbolServerModule = class SymbolServerModule {
};
SymbolServerModule = __decorate([
    common_1.Module({
        imports: [
            typeorm_1.TypeOrmModule.forFeature([symbolServer_1.SymbolServer]),
            platform_express_1.MulterModule.register({
                dest: env_1.env.path.secretDir,
            }),
            common_1.forwardRef(() => symbol_item_module_1.SymbolItemModule),
            project_module_1.ProjectModule,
            proxy_module_1.ProxyModule,
            server_credentials_module_1.ServerCredentialsModule,
            universe_module_1.UniverseModule,
        ],
        providers: [symbol_server_service_1.SymbolServerService, symbolServer_startup_1.SymbolServerStartup],
        controllers: [symbol_server_controller_1.SymbolServerController],
        exports: [symbol_server_service_1.SymbolServerService],
    })
], SymbolServerModule);
exports.SymbolServerModule = SymbolServerModule;
//# sourceMappingURL=symbol-server.module.js.map