"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerCredentials = exports.SymbolNameType = void 0;
const typeorm_1 = require("typeorm");
const symbolServer_1 = require("./symbolServer");
const credentialsType_1 = require("./types/credentialsType");
var SymbolNameType;
(function (SymbolNameType) {
    SymbolNameType[SymbolNameType["NoChange"] = 0] = "NoChange";
    SymbolNameType[SymbolNameType["LowerCase"] = 1] = "LowerCase";
    SymbolNameType[SymbolNameType["UpperCase"] = 2] = "UpperCase";
})(SymbolNameType = exports.SymbolNameType || (exports.SymbolNameType = {}));
let ServerCredentials = class ServerCredentials {
    get accessKeyId() {
        return this.userName;
    }
    get secretAccessKey() {
        return this.password;
    }
    updateAwsConnection() {
        if (this.type !== credentialsType_1.CredentialsType.AWS) {
            return;
        }
        this.awsConnection = {
            bucketName: this.bucketName,
            lowerFile: this.lowerFile,
            lowerId: this.lowerId,
            usePdb: this.usePdb,
        };
    }
};
__decorate([
    typeorm_1.PrimaryGeneratedColumn(),
    __metadata("design:type", Number)
], ServerCredentials.prototype, "id", void 0);
__decorate([
    typeorm_1.Column({ default: 0 }),
    __metadata("design:type", Number)
], ServerCredentials.prototype, "type", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", String)
], ServerCredentials.prototype, "userName", void 0);
__decorate([
    typeorm_1.Column({ select: false }),
    __metadata("design:type", String)
], ServerCredentials.prototype, "password", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", String)
], ServerCredentials.prototype, "bucketName", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", Number)
], ServerCredentials.prototype, "lowerFile", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", Number)
], ServerCredentials.prototype, "lowerId", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", Boolean)
], ServerCredentials.prototype, "usePdb", void 0);
__decorate([
    typeorm_1.Column({ nullable: true }),
    __metadata("design:type", String)
], ServerCredentials.prototype, "secretFile", void 0);
__decorate([
    typeorm_1.Column(),
    __metadata("design:type", Object)
], ServerCredentials.prototype, "symbolServerId", void 0);
__decorate([
    typeorm_1.OneToOne((type) => symbolServer_1.SymbolServer, (symbolServer) => symbolServer.serverCredentials, {
        onDelete: 'CASCADE',
    }),
    typeorm_1.JoinColumn({ name: 'symbolServerId' }),
    __metadata("design:type", symbolServer_1.SymbolServer)
], ServerCredentials.prototype, "symbolServer", void 0);
__decorate([
    typeorm_1.AfterLoad(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ServerCredentials.prototype, "updateAwsConnection", null);
ServerCredentials = __decorate([
    typeorm_1.Entity()
], ServerCredentials);
exports.ServerCredentials = ServerCredentials;
//# sourceMappingURL=serverCredentials.js.map