"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RetryLimitAndTimeoutDefaultValuesMigration1565552139989 = void 0;
class RetryLimitAndTimeoutDefaultValuesMigration1565552139989 {
    async up(queryRunner) {
        await queryRunner.query(`CREATE TABLE "temporary_symbol_server_statistics" ("id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, "numberOfBytesDownloaded" bigint NOT NULL DEFAULT (0), "numberOfFailuresAtDownloadStage" integer NOT NULL DEFAULT (0), "numberOfSuccessAtDownloadStage" integer NOT NULL DEFAULT (0), "numberOfSuccessAtSymbolConversionStage" integer NOT NULL DEFAULT (0), "numberOfFailuresAtSymbolConversionStage" integer NOT NULL DEFAULT (0), "symbolServerId" integer NOT NULL, "lastUpdateDate" datetime NOT NULL DEFAULT (datetime('now')), CONSTRAINT "UQ_40711d18d440a726cc3e1b9993a" UNIQUE ("symbolServerId"), CONSTRAINT "FK_40711d18d440a726cc3e1b9993a" FOREIGN KEY ("symbolServerId") REFERENCES "symbol_server" ("id") ON DELETE CASCADE ON UPDATE NO ACTION)`);
        await queryRunner.query(`INSERT INTO "temporary_symbol_server_statistics"("id", "numberOfBytesDownloaded", "numberOfFailuresAtDownloadStage", "numberOfSuccessAtDownloadStage", "numberOfSuccessAtSymbolConversionStage", "numberOfFailuresAtSymbolConversionStage", "symbolServerId") SELECT "id", "numberOfBytesDownloaded", "numberOfFailuresAtDownloadStage", "numberOfSuccessAtDownloadStage", "numberOfSuccessAtSymbolConversionStage", "numberOfFailuresAtSymbolConversionStage", "symbolServerId" FROM "symbol_server_statistics"`);
        await queryRunner.query(`DROP TABLE "symbol_server_statistics"`);
        await queryRunner.query(`ALTER TABLE "temporary_symbol_server_statistics" RENAME TO "symbol_server_statistics"`);
        await queryRunner.query(`update 
            symbol_server set retryLimit = 1, retryTimeout = 1000 
          where 
            url != "https://s3-us-west-2.amazonaws.com" 
            AND url != 'https://lgapi.crypticspace.com:442/symbols/d89jvmmWsVVprFxOOq/'
            AND projectId is NULL AND universeId is NULL;`);
    }
    async down(queryRunner) {
        await queryRunner.query(`ALTER TABLE "symbol_server_statistics" RENAME TO "temporary_symbol_server_statistics"`);
        await queryRunner.query(`CREATE TABLE "symbol_server_statistics" ("id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, "numberOfBytesDownloaded" bigint NOT NULL DEFAULT (0), "numberOfFailuresAtDownloadStage" integer NOT NULL DEFAULT (0), "numberOfSuccessAtDownloadStage" integer NOT NULL DEFAULT (0), "numberOfSuccessAtSymbolConversionStage" integer NOT NULL DEFAULT (0), "numberOfFailuresAtSymbolConversionStage" integer NOT NULL DEFAULT (0), "symbolServerId" integer NOT NULL, CONSTRAINT "UQ_40711d18d440a726cc3e1b9993a" UNIQUE ("symbolServerId"), CONSTRAINT "FK_40711d18d440a726cc3e1b9993a" FOREIGN KEY ("symbolServerId") REFERENCES "symbol_server" ("id") ON DELETE CASCADE ON UPDATE NO ACTION)`);
        await queryRunner.query(`INSERT INTO "symbol_server_statistics"("id", "numberOfBytesDownloaded", "numberOfFailuresAtDownloadStage", "numberOfSuccessAtDownloadStage", "numberOfSuccessAtSymbolConversionStage", "numberOfFailuresAtSymbolConversionStage", "symbolServerId") SELECT "id", "numberOfBytesDownloaded", "numberOfFailuresAtDownloadStage", "numberOfSuccessAtDownloadStage", "numberOfSuccessAtSymbolConversionStage", "numberOfFailuresAtSymbolConversionStage", "symbolServerId" FROM "temporary_symbol_server_statistics"`);
        await queryRunner.query(`DROP TABLE "temporary_symbol_server_statistics"`);
    }
}
exports.RetryLimitAndTimeoutDefaultValuesMigration1565552139989 = RetryLimitAndTimeoutDefaultValuesMigration1565552139989;
//# sourceMappingURL=1565552139989-RetryLimitAndTimeoutDefaultValuesMigration.js.map