"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwsToCloudBuckets1574773953780 = void 0;
class AwsToCloudBuckets1574773953780 {
    constructor() {
        this.name = 'AwsToCloudBuckets1574773953780';
    }
    async up(queryRunner) {
        await queryRunner.query(`CREATE TABLE "temporary_server_credentials" (
          "id" integer PRIMARY KEY AUTOINCREMENT NOT NULL, 
          "userName" varchar, 
          "password" varchar, 
          "symbolServerId" integer NOT NULL, 
          "bucketName" varchar , 
          "lowerFile" boolean, 
          "lowerId" boolean, 
          "usePdb" boolean, 
          "type" integer NOT NULL DEFAULT (0), 
          "secretFile" varchar,
          CONSTRAINT "UQ_025e77be0b6547cef1749423830" UNIQUE ("symbolServerId"), 
          CONSTRAINT "FK_025e77be0b6547cef1749423830" FOREIGN KEY ("symbolServerId") REFERENCES "symbol_server" ("id") ON DELETE CASCADE ON UPDATE NO ACTION)`, undefined);
        await queryRunner.query(`INSERT INTO 
        "temporary_server_credentials"("id", "userName", "password", "symbolServerId", "bucketName", "lowerFile", "lowerId", "usePdb", "type")
        SELECT "sc"."id", "userName", "password", "symbolServerId", "bucketName", "lowerFile", "lowerId", "usePdb", case WHEN "awsc"."bucketName" is NOT NULL then 1 else 0 end as "type"
        FROM "server_credentials" as "sc"
        LEFT OUTER JOIN "aws_connection" as "awsc"
        ON "awsc".serverCredentialsId = "sc".id`, undefined);
        await queryRunner.query(`DROP TABLE "server_credentials"`, undefined);
        await queryRunner.query(`ALTER TABLE "temporary_server_credentials" RENAME TO "server_credentials"`, undefined);
        await queryRunner.query(`alter table symbol_server
        add queryBuilder varchar
      `, undefined);
        await queryRunner.query(`alter table symbol_server
      add hidden boolean default false
      `, undefined);
        await queryRunner.query(`drop table aws_connection`);
    }
    async down(queryRunner) { }
}
exports.AwsToCloudBuckets1574773953780 = AwsToCloudBuckets1574773953780;
//# sourceMappingURL=1574773953780-AwsToCloudBuckets.js.map