"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.env = exports.updateCoronerdUrl = exports.onCoronerdUpdate = exports.coronerdUrl = exports.service = exports.port = exports.readSslCerts = void 0;
const backtrace_service_1 = require("backtrace-service");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
function readSslCerts() {
    var _a;
    switch ((_a = exports.service.configuration.descriptor) === null || _a === void 0 ? void 0 : _a.protocol) {
        case 'http':
            return undefined;
        case 'https':
            return {
                key: fs.readFileSync(exports.service.configuration.ssl.key, 'utf8'),
                cert: fs.readFileSync(exports.service.configuration.ssl.cert, 'utf8'),
            };
    }
}
exports.readSslCerts = readSslCerts;
const serviceName = 'symbold';
exports.port = 6447;
const opts = process.env.NODE_ENV === 'test' && process.env.TEST_CONFIG
    ? { confPath: process.env.TEST_CONFIG }
    : {};
exports.service = backtrace_service_1.BacktraceService.bootstrap(serviceName, exports.port, Object.assign(Object.assign({}, opts), {
    coronerdCallback: (url) => {
        updateCoronerdUrl(url);
    },
}));
if (!exports.service.configuration.path.secretDir) {
    exports.service.configuration.path.secretDir = path.join(process.cwd(), 'operations');
}
exports.service.configuration.path.eventPaths = [];
if (exports.service.configuration.path.queue) {
    exports.service.configuration.path.eventPaths.push(exports.service.configuration.path.queue);
}
function updateCoronerdUrl(url) {
    if (exports.coronerdUrl) {
        return;
    }
    exports.coronerdUrl = url;
    if (exports.onCoronerdUpdate) {
        exports.onCoronerdUpdate(url);
    }
}
exports.updateCoronerdUrl = updateCoronerdUrl;
exports.env = exports.service.configuration;
//# sourceMappingURL=env.js.map