"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthHelper = void 0;
class AuthHelper {
    static checkUserAccess(auth, universeName, projectName) {
        if (!universeName || !(auth === null || auth === void 0 ? void 0 : auth.cfg)) {
            return false;
        }
        const config = auth.cfg;
        return ((config.universe.name === universeName && !projectName) ||
            (projectName &&
                config.universes[universeName] &&
                config.universes[universeName].projects.indexOf(projectName) !== -1) ||
            config.email.endsWith('@backtrace.io'));
    }
    static isSuperUser(auth) {
        if (!(auth === null || auth === void 0 ? void 0 : auth.cfg)) {
            return false;
        }
        const config = auth.cfg;
        return config.user.superuser === 1;
    }
}
exports.AuthHelper = AuthHelper;
//# sourceMappingURL=authHelper.js.map