"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseIntArrayPipe = void 0;
const common_1 = require("@nestjs/common");
let ParseIntArrayPipe = class ParseIntArrayPipe {
    transform(value, metadata) {
        if (!value || !value.data) {
            throw new common_1.BadRequestException('Empty data');
        }
        const result = [];
        value.data.forEach((val) => {
            if (isNaN(val) || typeof val === 'string') {
                return;
            }
            result.push(val);
        });
        if (result.length === 0) {
            throw new common_1.BadRequestException('Parse result generate empty int array');
        }
        return { data: [...new Set(result)] };
    }
};
ParseIntArrayPipe = __decorate([
    common_1.Injectable()
], ParseIntArrayPipe);
exports.ParseIntArrayPipe = ParseIntArrayPipe;
//# sourceMappingURL=parseIntArray.js.map