"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UniverseHelper = void 0;
var url = __importStar(require("url"));
/**
 * Backtrae universe utils
 */
var UniverseHelper = /** @class */ (function () {
    function UniverseHelper() {
    }
    /**
     * return Backtrace host url
     * @param urlString sample url to any Backtrace resource
     * Example:
     * https://yolo.sp.backtrace.io => https://yolo.sp.backtrace.io
     * https://sampleHostName.backtrace.io/blah/poop/doop => https://sampleHostName.backtrace.io
     */
    UniverseHelper.getBacktraceHostName = function (urlString) {
        if (!urlString) {
            return undefined;
        }
        var obj = url.parse(urlString);
        return obj.protocol + "//" + obj.hostname;
    };
    /**
     * Get an universe name from Backtrace url.
     * @param urlString sample url to any Backtrace resource
     * Example:
     * https://yolo.sp.backtrace.io => yolo
     * https://sampleHostName.backtrace.io => sampleHostName
     */
    UniverseHelper.getBacktaceUniverseName = function (urlString) {
        if (!urlString) {
            return undefined;
        }
        var hostNameIndexEnd = urlString.indexOf('backtrace.io/');
        if (hostNameIndexEnd === -1) {
            return undefined;
        }
        return urlString.includes('submit.sp.backtrace.io')
            ? urlString.substring(hostNameIndexEnd, urlString.indexOf('/', hostNameIndexEnd))
            : urlString.substring(urlString.indexOf('//') + 2, urlString.indexOf('.sp.backtrace.io'));
    };
    return UniverseHelper;
}());
exports.UniverseHelper = UniverseHelper;
//# sourceMappingURL=backtraceUniverseHelper.js.map